<template>
  <ObModal
    ref="modal"
    size="medium"
    :title="modalTitle"
    :is-show-controls="true"
    :is-only-submit="true"
    :ok-text="okText"
    data-qa="signContractDraftFinal"
    :is-close-on-overlay="false"
    @submit="onSignAfter(true)"
    @close="onSignAfter"
  >
    <template v-if="isTitul">
      <p>Договор отправлен контрагенту {{ participant }} на подпись.</p>
      <p>Через 15 секунд вы перейдёте в Браузер договоров автоматически.</p>
    </template>
    <template v-else-if="isTariffAgreement">
      <p>Договор отправлен контрагенту {{ participant }} на подпись.</p>
      <p>Через 15 секунд вы перейдёте в договор-титул автоматически.</p>
    </template>
    <template v-else>
      <p>Договор отправлен контрагенту {{ participant }} на подпись.</p>
      <p>Через 15 секунд вы перейдёте в Браузер договоров автоматически.</p>
    </template>
  </ObModal>
</template>

<script>
import { mapGetters } from 'vuex'
import ObModal from 'common-components/src/obComponents/obModal'

export default {
  name: 'SignContractDraftFinalModal',
  props: {
    participant: {
      type: String,
      default: ''
    },
    contract: {
      type: Object,
      default: () => {}
    }
  },
  components: {
    ObModal
  },
  data () {
    return {
      timeout: null,
      inProcess: false
    }
  },
  beforeDestroy () {
    clearTimeout(this.timeout)
  },
  computed: {
    ...mapGetters({
      isTitul: 'contract/isTitul',
      isTariffAgreement: 'contract/isTariffAgreement',
    }),
    modalTitle () {
      return 'Договор отправлен на подпись'
    },
    okText () {
      return 'Остаться для просмотра договора'
    }
  },
  methods: {
    open () {
      this.timeout = setTimeout(() => {
        this.onSignAfter()
      }, 15000)
      this.$refs.modal.open()
    },
    close () {
      clearTimeout(this.timeout)
      this.$refs.modal.close()
    },
    goToContractsList () {
      this.$router.push({ name: 'contracts__list-signing-to'})
    },
    onSignAfter (isOk = false) {
      if (this.inProcess) {
        this.inProcess = false
        return false
      }

      this.inProcess = true
      this.close()

      if (this.isTitul) {
        if (!isOk) {
          this.goToContractsList()
        }
        // this.$eventGlobal.$emit('change-contract-tab', { uuid: 'tariff_agreement' })
      } else if (this.isTariffAgreement) {
        if (!isOk) {
          this.$router.push({ name: 'contracts__detail', params: { id: this.contract.parentContractData?.parentContractUuid } })
        }
      } else {
        this.goToContractsList()
      }
    }
  }
}
</script>
